Index: kernel/genarch/src/drivers/i8259/i8259.c
===================================================================
--- kernel/genarch/src/drivers/i8259/i8259.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
+++ kernel/genarch/src/drivers/i8259/i8259.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -0,0 +1,172 @@
+/*
+ * Copyright (c) 2001-2004 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup kernel_genarch
+ * @{
+ */
+/**
+ * @file
+ * @brief i8259 driver.
+ *
+ * Programmable Interrupt Controller for UP systems based on i8259 chip.
+ */
+
+#include <genarch/drivers/i8259/i8259.h>
+#include <typedefs.h>
+#include <stdint.h>
+#include <log.h>
+#include <interrupt.h>
+
+/* ICW1 bits */
+#define I8259_ICW1           (1 << 4)
+#define I8259_ICW1_NEEDICW4  (1 << 0)
+
+/* OCW3 bits */
+#define I8259_OCW3           (1 << 3)
+#define I8259_OCW3_READ_ISR  (3 << 0)
+
+/* OCW4 bits */
+#define I8259_OCW4           (0 << 3)
+#define I8259_OCW4_NSEOI     (1 << 5)
+
+#define I8259_IRQ_COUNT 8
+
+#define I8259_IRQ_SLAVE 2
+
+static const char *i8259_get_name(void);
+
+pic_ops_t i8259_pic_ops = {
+	.get_name = i8259_get_name,
+	.enable_irqs = i8259_enable_irqs,
+	.disable_irqs = i8259_disable_irqs,
+	.eoi = i8259_eoi,
+	.is_spurious = i8259_is_spurious,
+	.handle_spurious = i8259_handle_spurious
+};
+
+// XXX: need to change pic_* API to get rid of these
+static i8259_t *saved_pic0;
+static i8259_t *saved_pic1;
+
+void i8259_init(i8259_t *pic0, i8259_t *pic1, unsigned int irq0_vec)
+{
+	saved_pic0 = pic0;
+	saved_pic1 = pic1;
+
+	/* ICW1: this is ICW1, ICW4 to follow */
+	pio_write_8(&pic0->port1, I8259_ICW1 | I8259_ICW1_NEEDICW4);
+
+	/* ICW2: IRQ 0 maps to interrupt vector address irq0_vec */
+	pio_write_8(&pic0->port2, irq0_vec);
+
+	/* ICW3: pic1 using IRQ I8259_IRQ_SLAVE */
+	pio_write_8(&pic0->port2, 1 << I8259_IRQ_SLAVE);
+
+	/* ICW4: i8086 mode */
+	pio_write_8(&pic0->port2, 1);
+
+	/* ICW1: ICW1, ICW4 to follow */
+	pio_write_8(&pic1->port1, I8259_ICW1 | I8259_ICW1_NEEDICW4);
+
+	/* ICW2: IRQ 8 maps to interrupt vector address irq0_vec + 8 */
+	pio_write_8(&pic1->port2, irq0_vec + I8259_IRQ_COUNT);
+
+	/* ICW3: pic1 is known as I8259_IRQ_SLAVE */
+	pio_write_8(&pic1->port2, I8259_IRQ_SLAVE);
+
+	/* ICW4: i8086 mode */
+	pio_write_8(&pic1->port2, 1);
+
+	/* disable all irq's */
+	i8259_disable_irqs(0xffff);
+	/* but enable I8259_IRQ_SLAVE */
+	i8259_enable_irqs(1 << I8259_IRQ_SLAVE);
+}
+
+const char *i8259_get_name(void)
+{
+	return "i8259";
+}
+
+void i8259_enable_irqs(uint16_t irqmask)
+{
+	uint8_t x;
+
+	if (irqmask & 0xff) {
+		x = pio_read_8(&saved_pic0->port2);
+		pio_write_8(&saved_pic0->port2,
+		    (uint8_t) (x & (~(irqmask & 0xff))));
+	}
+	if (irqmask >> I8259_IRQ_COUNT) {
+		x = pio_read_8(&saved_pic1->port2);
+		pio_write_8(&saved_pic1->port2,
+		    (uint8_t) (x & (~(irqmask >> I8259_IRQ_COUNT))));
+	}
+}
+
+void i8259_disable_irqs(uint16_t irqmask)
+{
+	uint8_t x;
+
+	if (irqmask & 0xff) {
+		x = pio_read_8(&saved_pic0->port2);
+		pio_write_8(&saved_pic0->port2,
+		    (uint8_t) (x | (irqmask & 0xff)));
+	}
+	if (irqmask >> I8259_IRQ_COUNT) {
+		x = pio_read_8(&saved_pic1->port2);
+		pio_write_8(&saved_pic1->port2,
+		    (uint8_t) (x | (irqmask >> I8259_IRQ_COUNT)));
+	}
+}
+
+void i8259_eoi(unsigned int irq)
+{
+	if (irq >= I8259_IRQ_COUNT)
+		pio_write_8(&saved_pic1->port1, I8259_OCW4 | I8259_OCW4_NSEOI);
+	pio_write_8(&saved_pic0->port1, I8259_OCW4 | I8259_OCW4_NSEOI);
+}
+
+bool i8259_is_spurious(unsigned int irq)
+{
+	pio_write_8(&saved_pic0->port1, I8259_OCW3 | I8259_OCW3_READ_ISR);
+	pio_write_8(&saved_pic1->port1, I8259_OCW3 | I8259_OCW3_READ_ISR);
+	uint8_t isr_lo = pio_read_8(&saved_pic0->port1);
+	uint8_t isr_hi = pio_read_8(&saved_pic1->port1);
+	return !(((isr_hi << I8259_IRQ_COUNT) | isr_lo) & (1 << irq));
+}
+
+void i8259_handle_spurious(unsigned int irq)
+{
+	/* For spurious IRQs from pic1, we need to isssue an EOI to pic0 */
+	if (irq >= I8259_IRQ_COUNT)
+		pio_write_8(&saved_pic0->port1, I8259_OCW4 | I8259_OCW4_NSEOI);
+}
+
+/** @}
+ */
Index: kernel/genarch/src/drivers/ns16550/ns16550.c
===================================================================
--- kernel/genarch/src/drivers/ns16550/ns16550.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/genarch/src/drivers/ns16550/ns16550.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -39,7 +39,9 @@
 #include <genarch/drivers/ns16550/ns16550.h>
 #include <ddi/irq.h>
+#include <ddi/ddi.h>
 #include <arch/asm.h>
 #include <console/chardev.h>
 #include <stdlib.h>
+#include <align.h>
 #include <str.h>
 
@@ -143,9 +145,11 @@
  *
  */
-ns16550_instance_t *ns16550_init(ioport8_t *dev, unsigned reg_shift, inr_t inr,
-    cir_t cir, void *cir_arg, outdev_t **output)
-{
-	ns16550_instance_t *instance =
-	    malloc(sizeof(ns16550_instance_t));
+ns16550_instance_t *ns16550_init(ioport8_t *dev_phys, unsigned reg_shift,
+    inr_t inr, cir_t cir, void *cir_arg, outdev_t **output)
+{
+	size_t size = 6 * (1U << reg_shift);
+	ioport8_t *dev = pio_map((void *) dev_phys, size);
+
+	ns16550_instance_t *instance = malloc(sizeof(ns16550_instance_t));
 	if (instance) {
 		instance->ns16550 = dev;
@@ -158,4 +162,6 @@
 			if (!instance->output) {
 				free(instance);
+				pio_unmap((void *) dev_phys, (void *) dev,
+				    size);
 				return NULL;
 			}
@@ -176,6 +182,7 @@
 
 		ddi_parea_init(&instance->parea);
-		instance->parea.pbase = (uintptr_t) dev;
-		instance->parea.frames = 1;
+		instance->parea.pbase = ALIGN_DOWN((uintptr_t) dev_phys,
+		    PAGE_SIZE);
+		instance->parea.frames = ALIGN_UP(size, PAGE_SIZE);
 		instance->parea.unpriv = false;
 		instance->parea.mapped = false;
Index: kernel/genarch/src/drivers/pl011/pl011.c
===================================================================
--- kernel/genarch/src/drivers/pl011/pl011.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/genarch/src/drivers/pl011/pl011.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -60,7 +60,11 @@
 	pl011_uart_t *uart = dev->data;
 
-	if (!ascii_check(ch)) {
+	/* If the userspace owns the console, do not output anything. */
+	if (uart->parea.mapped && !console_override)
+		return;
+
+	if (!ascii_check(ch))
 		pl011_uart_sendb(uart, U_SPECIAL);
-	} else {
+	else {
 		if (ch == '\n')
 			pl011_uart_sendb(uart, (uint8_t) '\r');
@@ -100,5 +104,5 @@
 	assert(uart);
 	uart->regs = (void *)km_map(addr, sizeof(pl011_uart_regs_t),
-	    KM_NATURAL_ALIGNMENT, PAGE_NOT_CACHEABLE);
+	    KM_NATURAL_ALIGNMENT, PAGE_WRITE | PAGE_NOT_CACHEABLE);
 	assert(uart->regs);
 
@@ -131,4 +135,11 @@
 	uart->irq.instance = uart;
 
+	ddi_parea_init(&uart->parea);
+	uart->parea.pbase = addr;
+	uart->parea.frames = 1;
+	uart->parea.unpriv = false;
+	uart->parea.mapped = false;
+	ddi_parea_register(&uart->parea);
+
 	return true;
 }
Index: kernel/genarch/src/mm/as_pt.c
===================================================================
--- kernel/genarch/src/mm/as_pt.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/genarch/src/mm/as_pt.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -76,7 +76,7 @@
 	    PA2KA(frame_alloc(PTL0_FRAMES, FRAME_LOWMEM, PTL0_SIZE - 1));
 
-	if (flags & FLAG_AS_KERNEL)
-		memsetb(dst_ptl0, PTL0_SIZE, 0);
-	else {
+	memsetb(dst_ptl0, PTL0_SIZE, 0);
+
+	if (!KERNEL_SEPARATE_PTL0 && !(flags & FLAG_AS_KERNEL)) {
 		/*
 		 * Copy the kernel address space portion to new PTL0.
@@ -93,5 +93,4 @@
 		    &dst_ptl0[PTL0_INDEX(KERNEL_ADDRESS_SPACE_START)];
 
-		memsetb(dst_ptl0, PTL0_SIZE, 0);
 		memcpy((void *) dst, (void *) src,
 		    PTL0_SIZE - (src - (uintptr_t) src_ptl0));
Index: kernel/genarch/src/mm/page_ht.c
===================================================================
--- kernel/genarch/src/mm/page_ht.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/genarch/src/mm/page_ht.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -54,6 +54,6 @@
 
 static size_t ht_hash(const ht_link_t *);
-static size_t ht_key_hash(void *);
-static bool ht_key_equal(void *, const ht_link_t *);
+static size_t ht_key_hash(const void *);
+static bool ht_key_equal(const void *, const ht_link_t *);
 static void ht_remove_callback(ht_link_t *);
 
@@ -109,7 +109,7 @@
 
 /** Return the hash of the key. */
-size_t ht_key_hash(void *arg)
-{
-	uintptr_t *key = (uintptr_t *) arg;
+size_t ht_key_hash(const void *arg)
+{
+	const uintptr_t *key = arg;
 	size_t hash = 0;
 	hash = hash_combine(hash, key[KEY_AS]);
@@ -119,7 +119,7 @@
 
 /** Return true if the key is equal to the item's lookup key. */
-bool ht_key_equal(void *arg, const ht_link_t *item)
-{
-	uintptr_t *key = (uintptr_t *) arg;
+bool ht_key_equal(const void *arg, const ht_link_t *item)
+{
+	const uintptr_t *key = arg;
 	pte_t *pte = hash_table_get_inst(item, pte_t, link);
 	return (key[KEY_AS] == (uintptr_t) pte->as) &&
Index: kernel/genarch/src/multiboot/multiboot2.c
===================================================================
--- kernel/genarch/src/multiboot/multiboot2.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/genarch/src/multiboot/multiboot2.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -65,5 +65,5 @@
 	multiboot2_memmap_entry_t *entry = (multiboot2_memmap_entry_t *)
 	    ((uintptr_t) memmap + sizeof(*memmap));
-	uint32_t pos = sizeof(*memmap);
+	uint32_t pos = offsetof(multiboot2_tag_t, memmap) + sizeof(*memmap);
 
 	while ((pos < length) && (e820counter < MEMMAP_E820_MAX_RECORDS)) {
Index: kernel/generic/include/adt/hash_table.h
===================================================================
--- kernel/generic/include/adt/hash_table.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/generic/include/adt/hash_table.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -53,5 +53,5 @@
 
 	/** Returns the hash of the key. */
-	size_t (*key_hash)(void *key);
+	size_t (*key_hash)(const void *key);
 
 	/** True if the items are equal (have the same lookup keys). */
@@ -59,5 +59,5 @@
 
 	/** Returns true if the key is equal to the item's lookup key. */
-	bool (*key_equal)(void *key, const ht_link_t *item);
+	bool (*key_equal)(const void *key, const ht_link_t *item);
 
 	/** Hash table item removal callback.
@@ -94,8 +94,8 @@
 extern void hash_table_insert(hash_table_t *, ht_link_t *);
 extern bool hash_table_insert_unique(hash_table_t *, ht_link_t *);
-extern ht_link_t *hash_table_find(const hash_table_t *, void *);
+extern ht_link_t *hash_table_find(const hash_table_t *, const void *);
 extern ht_link_t *hash_table_find_next(const hash_table_t *, ht_link_t *,
     ht_link_t *);
-extern size_t hash_table_remove(hash_table_t *, void *);
+extern size_t hash_table_remove(hash_table_t *, const void *);
 extern void hash_table_remove_item(hash_table_t *, ht_link_t *);
 extern void hash_table_apply(hash_table_t *, bool (*)(ht_link_t *, void *),
Index: kernel/generic/include/console/console.h
===================================================================
--- kernel/generic/include/console/console.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/generic/include/console/console.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -71,5 +71,5 @@
 extern wchar_t getc(indev_t *indev);
 extern size_t gets(indev_t *indev, char *buf, size_t buflen);
-extern sys_errno_t sys_kio(int cmd, const void *buf, size_t size);
+extern sys_errno_t sys_kio(int cmd, uspace_addr_t buf, size_t size);
 
 extern void grab_console(void);
Index: kernel/generic/include/ddi/ddi.h
===================================================================
--- kernel/generic/include/ddi/ddi.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/generic/include/ddi/ddi.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -60,14 +60,17 @@
 extern void ddi_parea_register(parea_t *);
 
-extern sys_errno_t sys_physmem_map(uintptr_t, size_t, unsigned int, void *,
+extern void *pio_map(void *, size_t);
+extern void pio_unmap(void *, void *, size_t);
+
+extern sys_errno_t sys_physmem_map(uintptr_t, size_t, unsigned int, uspace_ptr_uintptr_t,
     uintptr_t);
 extern sys_errno_t sys_physmem_unmap(uintptr_t);
 
-extern sys_errno_t sys_dmamem_map(size_t, unsigned int, unsigned int, void *,
-    void *, uintptr_t);
+extern sys_errno_t sys_dmamem_map(size_t, unsigned int, unsigned int, uspace_ptr_uintptr_t,
+    uspace_ptr_uintptr_t, uintptr_t);
 extern sys_errno_t sys_dmamem_unmap(uintptr_t, size_t, unsigned int);
 
-extern sys_errno_t sys_iospace_enable(ddi_ioarg_t *);
-extern sys_errno_t sys_iospace_disable(ddi_ioarg_t *);
+extern sys_errno_t sys_iospace_enable(uspace_ptr_ddi_ioarg_t);
+extern sys_errno_t sys_iospace_disable(uspace_ptr_ddi_ioarg_t);
 
 /*
Index: kernel/generic/include/ipc/irq.h
===================================================================
--- kernel/generic/include/ipc/irq.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/generic/include/ipc/irq.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -50,6 +50,6 @@
 extern void ipc_irq_top_half_handler(irq_t *);
 
-extern errno_t ipc_irq_subscribe(answerbox_t *, inr_t, sysarg_t, irq_code_t *,
-    cap_irq_handle_t *);
+extern errno_t ipc_irq_subscribe(answerbox_t *, inr_t, sysarg_t, uspace_ptr_irq_code_t,
+    uspace_ptr_cap_irq_handle_t);
 extern errno_t ipc_irq_unsubscribe(answerbox_t *, cap_irq_handle_t);
 
Index: kernel/generic/include/ipc/sysipc.h
===================================================================
--- kernel/generic/include/ipc/sysipc.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/generic/include/ipc/sysipc.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -44,22 +44,22 @@
 extern sys_errno_t sys_ipc_call_async_fast(cap_phone_handle_t, sysarg_t,
     sysarg_t, sysarg_t, sysarg_t, sysarg_t);
-extern sys_errno_t sys_ipc_call_async_slow(cap_phone_handle_t, ipc_data_t *,
+extern sys_errno_t sys_ipc_call_async_slow(cap_phone_handle_t, uspace_ptr_ipc_data_t,
     sysarg_t);
 extern sys_errno_t sys_ipc_answer_fast(cap_call_handle_t, sysarg_t, sysarg_t,
     sysarg_t, sysarg_t, sysarg_t);
-extern sys_errno_t sys_ipc_answer_slow(cap_call_handle_t, ipc_data_t *);
-extern sys_errno_t sys_ipc_wait_for_call(ipc_data_t *, uint32_t, unsigned int);
+extern sys_errno_t sys_ipc_answer_slow(cap_call_handle_t, uspace_ptr_ipc_data_t);
+extern sys_errno_t sys_ipc_wait_for_call(uspace_ptr_ipc_data_t, uint32_t, unsigned int);
 extern sys_errno_t sys_ipc_poke(void);
 extern sys_errno_t sys_ipc_forward_fast(cap_call_handle_t, cap_phone_handle_t,
     sysarg_t, sysarg_t, sysarg_t, unsigned int);
 extern sys_errno_t sys_ipc_forward_slow(cap_call_handle_t, cap_phone_handle_t,
-    ipc_data_t *, unsigned int);
+    uspace_ptr_ipc_data_t, unsigned int);
 extern sys_errno_t sys_ipc_hangup(cap_phone_handle_t);
 
-extern sys_errno_t sys_ipc_irq_subscribe(inr_t, sysarg_t, irq_code_t *,
-    cap_irq_handle_t *);
+extern sys_errno_t sys_ipc_irq_subscribe(inr_t, sysarg_t, uspace_ptr_irq_code_t,
+    uspace_ptr_cap_irq_handle_t);
 extern sys_errno_t sys_ipc_irq_unsubscribe(cap_irq_handle_t);
 
-extern sys_errno_t sys_ipc_connect_kbox(task_id_t *, cap_phone_handle_t *);
+extern sys_errno_t sys_ipc_connect_kbox(uspace_ptr_task_id_t, uspace_ptr_cap_phone_handle_t);
 
 #endif
Index: kernel/generic/include/lib/elf_load.h
===================================================================
--- kernel/generic/include/lib/elf_load.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/generic/include/lib/elf_load.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -38,16 +38,5 @@
 #include <abi/elf.h>
 
-/**
- * ELF error return codes
- */
-#define EE_OK             0  /* No error */
-#define EE_INVALID        1  /* Invalid ELF image */
-#define EE_MEMORY         2  /* Cannot allocate address space */
-#define EE_INCOMPATIBLE   3  /* ELF image is not compatible with current architecture */
-#define EE_UNSUPPORTED    4  /* Non-supported ELF (e.g. dynamic ELFs) */
-#define EE_IRRECOVERABLE  5  /* Irrecoverable error. */
-
-extern unsigned int elf_load(elf_header_t *, as_t *);
-extern const char *elf_error(unsigned int rc);
+extern errno_t elf_load(elf_header_t *, as_t *);
 
 #endif
Index: kernel/generic/include/log.h
===================================================================
--- kernel/generic/include/log.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/generic/include/log.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -52,6 +52,6 @@
     _HELENOS_PRINTF_ATTRIBUTE(3, 4);
 
-extern sys_errno_t sys_klog(sysarg_t, void *buf, size_t size,
-    sysarg_t level, size_t *uspace_nread);
+extern sys_errno_t sys_klog(sysarg_t, uspace_addr_t buf, size_t size,
+    sysarg_t level, uspace_ptr_size_t uspace_nread);
 
 #endif /* KERN_LOG_H_ */
Index: kernel/generic/include/mm/as.h
===================================================================
--- kernel/generic/include/mm/as.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/generic/include/mm/as.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -59,4 +59,10 @@
 #define KERNEL_ADDRESS_SPACE_SHADOWED  KERNEL_ADDRESS_SPACE_SHADOWED_ARCH
 
+/**
+ * Defined to be true if user address space and kernel address space do not
+ * share the same page table.
+ */
+#define KERNEL_SEPARATE_PTL0 KERNEL_SEPARATE_PTL0_ARCH
+
 #define KERNEL_ADDRESS_SPACE_START  KERNEL_ADDRESS_SPACE_START_ARCH
 #define KERNEL_ADDRESS_SPACE_END    KERNEL_ADDRESS_SPACE_END_ARCH
@@ -367,8 +373,8 @@
 /* Address space area related syscalls. */
 extern sysarg_t sys_as_area_create(uintptr_t, size_t, unsigned int, uintptr_t,
-    as_area_pager_info_t *);
+    uspace_ptr_as_area_pager_info_t);
 extern sys_errno_t sys_as_area_resize(uintptr_t, size_t, unsigned int);
 extern sys_errno_t sys_as_area_change_flags(uintptr_t, unsigned int);
-extern sys_errno_t sys_as_area_get_info(uintptr_t, as_area_info_t *);
+extern sys_errno_t sys_as_area_get_info(uintptr_t, uspace_ptr_as_area_info_t);
 extern sys_errno_t sys_as_area_destroy(uintptr_t);
 
Index: kernel/generic/include/mm/page.h
===================================================================
--- kernel/generic/include/mm/page.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/generic/include/mm/page.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -68,5 +68,5 @@
 
 extern errno_t page_find_mapping(uintptr_t, uintptr_t *);
-extern sys_errno_t sys_page_find_mapping(uintptr_t, uintptr_t *);
+extern sys_errno_t sys_page_find_mapping(uintptr_t, uspace_ptr_uintptr_t);
 
 #endif
Index: kernel/generic/include/proc/program.h
===================================================================
--- kernel/generic/include/proc/program.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/generic/include/proc/program.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -50,15 +50,15 @@
 	struct task *task;           /**< Program task */
 	struct thread *main_thread;  /**< Program main thread */
-	unsigned int loader_status;  /**< Binary loader error status */
+	errno_t loader_status;  /**< Binary loader error status */
 } program_t;
 
 extern void *program_loader;
 
-extern errno_t program_create(as_t *, uintptr_t, char *, program_t *);
+extern errno_t program_create(as_t *, uspace_addr_t, char *, program_t *);
 extern errno_t program_create_from_image(void *, char *, program_t *);
 extern errno_t program_create_loader(program_t *, char *);
 extern void program_ready(program_t *);
 
-extern sys_errno_t sys_program_spawn_loader(char *, size_t);
+extern sys_errno_t sys_program_spawn_loader(uspace_ptr_char, size_t);
 
 #endif
Index: kernel/generic/include/proc/task.h
===================================================================
--- kernel/generic/include/proc/task.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/generic/include/proc/task.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -164,5 +164,5 @@
 
 #ifdef __32_BITS__
-extern sys_errno_t sys_task_get_id(sysarg64_t *);
+extern sys_errno_t sys_task_get_id(uspace_ptr_sysarg64_t);
 #endif
 
@@ -171,6 +171,6 @@
 #endif
 
-extern sys_errno_t sys_task_set_name(const char *, size_t);
-extern sys_errno_t sys_task_kill(task_id_t *);
+extern sys_errno_t sys_task_set_name(uspace_ptr_const_char, size_t);
+extern sys_errno_t sys_task_kill(uspace_ptr_task_id_t);
 extern sys_errno_t sys_task_exit(sysarg_t);
 
Index: kernel/generic/include/proc/thread.h
===================================================================
--- kernel/generic/include/proc/thread.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/generic/include/proc/thread.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -265,8 +265,8 @@
 
 /* Thread syscall prototypes. */
-extern sys_errno_t sys_thread_create(uspace_arg_t *, char *, size_t,
-    thread_id_t *);
+extern sys_errno_t sys_thread_create(uspace_ptr_uspace_arg_t, uspace_ptr_char, size_t,
+    uspace_ptr_thread_id_t);
 extern sys_errno_t sys_thread_exit(int);
-extern sys_errno_t sys_thread_get_id(thread_id_t *);
+extern sys_errno_t sys_thread_get_id(uspace_ptr_thread_id_t);
 extern sys_errno_t sys_thread_usleep(uint32_t);
 extern sys_errno_t sys_thread_udelay(uint32_t);
Index: kernel/generic/include/security/perm.h
===================================================================
--- kernel/generic/include/security/perm.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/generic/include/security/perm.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -75,6 +75,6 @@
 #ifdef __32_BITS__
 
-extern sys_errno_t sys_perm_grant(sysarg64_t *, perm_t);
-extern sys_errno_t sys_perm_revoke(sysarg64_t *, perm_t);
+extern sys_errno_t sys_perm_grant(uspace_ptr_sysarg64_t, perm_t);
+extern sys_errno_t sys_perm_revoke(uspace_ptr_sysarg64_t, perm_t);
 
 #endif  /* __32_BITS__ */
Index: kernel/generic/include/synch/syswaitq.h
===================================================================
--- kernel/generic/include/synch/syswaitq.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/generic/include/synch/syswaitq.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -43,5 +43,5 @@
 extern void sys_waitq_task_cleanup(void);
 
-extern sys_errno_t sys_waitq_create(cap_waitq_handle_t *);
+extern sys_errno_t sys_waitq_create(uspace_ptr_cap_waitq_handle_t);
 extern sys_errno_t sys_waitq_sleep(cap_waitq_handle_t, uint32_t, unsigned int);
 extern sys_errno_t sys_waitq_wakeup(cap_waitq_handle_t);
Index: kernel/generic/include/syscall/copy.h
===================================================================
--- kernel/generic/include/syscall/copy.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/generic/include/syscall/copy.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -44,6 +44,6 @@
 extern char memcpy_to_uspace_failover_address;
 
-extern errno_t copy_from_uspace(void *dst, const void *uspace_src, size_t size);
-extern errno_t copy_to_uspace(void *dst_uspace, const void *src, size_t size);
+extern errno_t copy_from_uspace(void *dst, uspace_addr_t uspace_src, size_t size);
+extern errno_t copy_to_uspace(uspace_addr_t dst_uspace, const void *src, size_t size);
 
 /*
@@ -51,6 +51,6 @@
  * The functions return zero on failure and nonzero on success.
  */
-extern uintptr_t memcpy_from_uspace(void *dst, const void *uspace_src, size_t size);
-extern uintptr_t memcpy_to_uspace(void *uspace_dst, const void *src, size_t size);
+extern uintptr_t memcpy_from_uspace(void *dst, uspace_addr_t uspace_src, size_t size);
+extern uintptr_t memcpy_to_uspace(uspace_addr_t uspace_dst, const void *src, size_t size);
 
 #endif
Index: kernel/generic/include/sysinfo/sysinfo.h
===================================================================
--- kernel/generic/include/sysinfo/sysinfo.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/generic/include/sysinfo/sysinfo.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -162,10 +162,10 @@
 extern void sysinfo_dump(sysinfo_item_t *);
 
-extern sys_errno_t sys_sysinfo_get_keys_size(void *, size_t, void *);
-extern sys_errno_t sys_sysinfo_get_keys(void *, size_t, void *, size_t, size_t *);
-extern sysarg_t sys_sysinfo_get_val_type(void *, size_t);
-extern sys_errno_t sys_sysinfo_get_value(void *, size_t, void *);
-extern sys_errno_t sys_sysinfo_get_data_size(void *, size_t, void *);
-extern sys_errno_t sys_sysinfo_get_data(void *, size_t, void *, size_t, size_t *);
+extern sys_errno_t sys_sysinfo_get_keys_size(uspace_addr_t, size_t, uspace_addr_t);
+extern sys_errno_t sys_sysinfo_get_keys(uspace_addr_t, size_t, uspace_addr_t, size_t, uspace_ptr_size_t);
+extern sysarg_t sys_sysinfo_get_val_type(uspace_addr_t, size_t);
+extern sys_errno_t sys_sysinfo_get_value(uspace_addr_t, size_t, uspace_addr_t);
+extern sys_errno_t sys_sysinfo_get_data_size(uspace_addr_t, size_t, uspace_addr_t);
+extern sys_errno_t sys_sysinfo_get_data(uspace_addr_t, size_t, uspace_addr_t, size_t, uspace_ptr_size_t);
 
 #endif
Index: kernel/generic/include/udebug/udebug_ops.h
===================================================================
--- kernel/generic/include/udebug/udebug_ops.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/generic/include/udebug/udebug_ops.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -55,5 +55,5 @@
 errno_t udebug_regs_read(thread_t *t, void **buffer);
 
-errno_t udebug_mem_read(sysarg_t uspace_addr, size_t n, void **buffer);
+errno_t udebug_mem_read(uspace_addr_t uspace_addr, size_t n, void **buffer);
 
 #endif
Index: kernel/generic/src/adt/hash_table.c
===================================================================
--- kernel/generic/src/adt/hash_table.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/generic/src/adt/hash_table.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -51,6 +51,6 @@
 #include <adt/hash_table.h>
 #include <adt/list.h>
+#include <assert.h>
 #include <stdlib.h>
-#include <assert.h>
 #include <str.h>
 
@@ -245,5 +245,5 @@
  *
  */
-ht_link_t *hash_table_find(const hash_table_t *h, void *key)
+ht_link_t *hash_table_find(const hash_table_t *h, const void *key)
 {
 	assert(h && h->bucket);
@@ -306,5 +306,5 @@
  * @return Returns the number of removed items.
  */
-size_t hash_table_remove(hash_table_t *h, void *key)
+size_t hash_table_remove(hash_table_t *h, const void *key)
 {
 	assert(h && h->bucket);
Index: kernel/generic/src/cap/cap.c
===================================================================
--- kernel/generic/src/cap/cap.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/generic/src/cap/cap.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -88,6 +88,6 @@
 #include <stdlib.h>
 
-#define CAPS_START	(CAP_NIL + 1)
-#define CAPS_SIZE	(INT_MAX - CAPS_START)
+#define CAPS_START	((intptr_t) CAP_NIL + 1)
+#define CAPS_SIZE	(INT_MAX - (int) CAPS_START)
 #define CAPS_LAST	(CAPS_SIZE - 1)
 
@@ -98,16 +98,16 @@
 {
 	cap_t *cap = hash_table_get_inst(item, cap_t, caps_link);
-	return hash_mix(CAP_HANDLE_RAW(cap->handle));
-}
-
-static size_t caps_key_hash(void *key)
-{
-	cap_handle_t *handle = (cap_handle_t *) key;
-	return hash_mix(CAP_HANDLE_RAW(*handle));
-}
-
-static bool caps_key_equal(void *key, const ht_link_t *item)
-{
-	cap_handle_t *handle = (cap_handle_t *) key;
+	return hash_mix(cap_handle_raw(cap->handle));
+}
+
+static size_t caps_key_hash(const void *key)
+{
+	const cap_handle_t *handle = key;
+	return hash_mix(cap_handle_raw(*handle));
+}
+
+static bool caps_key_equal(const void *key, const ht_link_t *item)
+{
+	const cap_handle_t *handle = key;
 	cap_t *cap = hash_table_get_inst(item, cap_t, caps_link);
 	return *handle == cap->handle;
@@ -232,6 +232,6 @@
 	assert(mutex_locked(&task->cap_info->lock));
 
-	if ((CAP_HANDLE_RAW(handle) < CAPS_START) ||
-	    (CAP_HANDLE_RAW(handle) > CAPS_LAST))
+	if ((cap_handle_raw(handle) < CAPS_START) ||
+	    (cap_handle_raw(handle) > CAPS_LAST))
 		return NULL;
 	ht_link_t *link = hash_table_find(&task->cap_info->caps, &handle);
@@ -383,6 +383,6 @@
 void cap_free(task_t *task, cap_handle_t handle)
 {
-	assert(CAP_HANDLE_RAW(handle) >= CAPS_START);
-	assert(CAP_HANDLE_RAW(handle) <= CAPS_LAST);
+	assert(cap_handle_raw(handle) >= CAPS_START);
+	assert(cap_handle_raw(handle) <= CAPS_LAST);
 
 	mutex_lock(&task->cap_info->lock);
@@ -392,5 +392,5 @@
 
 	hash_table_remove_item(&task->cap_info->caps, &cap->caps_link);
-	ra_free(task->cap_info->handles, CAP_HANDLE_RAW(handle), 1);
+	ra_free(task->cap_info->handles, cap_handle_raw(handle), 1);
 	slab_free(cap_cache, cap);
 	mutex_unlock(&task->cap_info->lock);
Index: kernel/generic/src/console/console.c
===================================================================
--- kernel/generic/src/console/console.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/generic/src/console/console.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -395,5 +395,5 @@
  *
  */
-sys_errno_t sys_kio(int cmd, const void *buf, size_t size)
+sys_errno_t sys_kio(int cmd, uspace_addr_t buf, size_t size)
 {
 	char *data;
